package cz.vsb.fei.efrei.lab04;

import java.util.List;
import java.util.stream.Stream;

public class WorldOfStrongFighteres {
	public static void main(String[] args) {
		//generate names
		//map names to Heros  - create heros with name
		//filter out weaker then 100 (strength)
		//limit to 20 elemnts
		//print all to the consola
		
		
		Stream.generate(Utils::generateHeroName)
			.map(Hero::new)
//			.peek(hero -> System.out.println("All: " + hero))
			.filter(hero -> hero.getStrenght()>=100)
			.limit(20)
			.forEach(System.out::println);
		
		
		List<Army> armies = Stream.generate(Army::generate).limit(200).toList();
		
		double avgStrength = armies.stream().flatMap(a -> a.getSoldiers().stream())
			.mapToInt(fighter -> fighter.getStrenght()).average().orElse(0);
		System.out.println(avgStrength);

		armies.stream().flatMap(a -> a.getSoldiers().stream())
				.limit(0)
				.mapToInt(Fighter::getStrenght).average()
				.ifPresent(d -> System.out.println("Average is:" + d));

		System.out.println("==============================================");
		Stopwatch stopwatch = new Stopwatch();
		stopwatch.start();
		List<Army> a2 = Stream.generate(Army::generate).limit(200000).toList();
		double sum = a2.parallelStream().flatMap(a -> a.getSoldiers().stream())
		.mapToInt(Fighter::getStrenght).sum();
		//.ifPresent(d -> System.out.println("Average is:" + d));
		stopwatch.stop();
		System.out.println(stopwatch.formatDuration());
	}
}
